package edu.umsl.cs5012.groupproject;

import static org.junit.Assert.assertNotNull;

import edu.umsl.cs5012.groupproject.entity.*;
import edu.umsl.cs5012.groupproject.repo.OrderRepository;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import edu.umsl.cs5012.groupproject.repo.ProductRepository;
import edu.umsl.cs5012.groupproject.repo.UserRepository;

import java.util.Date;


@RunWith(SpringRunner.class)
@SpringBootTest
public class GroupprojectApplicationTests {

	@Autowired
	private UserRepository userRepository;
	
	@Autowired
	private ProductRepository productRepository;

	@Autowired
	private OrderRepository orderRepository;
	
	@Test
	public void contextLoads() {
	}
	

	
	
	@Before
	public void testMyRepository() {
		assertNotNull(userRepository);
		
		User user = new User();
		user.setLoginId("abcdef");
		user.setPassword("ghijk");
		
		Address address = new Address();
		address.setFirstname("firstnameline");
		address.setLastname("lastnameline");
		address.setAddress("addressline");
		address.setCity("cityline");
		address.setState("stateline");
		address.setZip("zipline");
		
		user.setAddress(address);
		
		User savedUser = userRepository.save(user);
		
		assertNotNull(savedUser);
		assertNotNull(savedUser.getId());
		
	}
	
	@Test
	public void testFindUser() {
		User user = userRepository.findById(1).orElse(null);
		
		assertNotNull(user);
		assertNotNull(user.getAddress());
		
		Address address = user.getAddress();
		
		System.out.println(address.getFirstname());
	}
	
	
	@Test
	public void testSaveProduct() {
		Product p1 = new Product();
		
		p1.setName("product1");
		p1.setPartnumber("12345");
		p1.setPrice(12.3f);
		p1.setImage("imageline2");
		
		Product savedProduct = productRepository.save(p1);
		assertNotNull(savedProduct);
		assertNotNull(savedProduct.getId());
		
	}

	@Test
	public void testSaveOrder(){
		Order order = new Order();
		//order.setUserId("testUserId");
		order.setTotalPrice(9.99f);
		//order.setAddressId("1234 Address");
		order.setOrderDate(new Date());

		OrderItem oi = new OrderItem();
		//oi.setProductsId("1");
		oi.setQuantity(2);
		oi.setTotalPrice(20.99f);
		//oi.setOrdersId("55");

		//order.addOrderItems(oi);

		Order savedOrder = orderRepository.save(order);
		assertNotNull(savedOrder);
		assertNotNull(savedOrder.getId());

	}



}
